

# A treemap R script produced by the REVIGO server at http://revigo.irb.hr/
# If you found REVIGO useful in your work, please cite the following reference:
# Supek F et al. "REVIGO summarizes and visualizes long lists of Gene Ontology
# terms" PLoS ONE 2011. doi:10.1371/journal.pone.0021800

# author: Anton Kratz <anton.kratz@gmail.com>, RIKEN Omics Science Center, Functional Genomics Technology Team, Japan
# created: Fri, Nov 02, 2012  7:25:52 PM
# last change: Fri, Nov 09, 2012  3:20:01 PM

# -----------------------------------------------------------------------------
# If you don't have the treemap package installed, uncomment the following line:
# install.packages( "treemap" );
library(treemap) 								# treemap package by Martijn Tennekes

# Set the working directory if necessary
# setwd("C:/Users/username/workingdir");

# --------------------------------------------------------------------------
# Here is your data from REVIGO. Scroll down for plot configuration options.

revigo.names <- c("term_ID","description","freqInDbPercent","value","uniqueness","dispensability","representative");
revigo.data <- rbind(c("GO:0007157","heterophilic cell-cell adhesion via plasma membrane cell adhesion molecules",0.008,0.8517,0.968,0.000,"heterophilic cell-cell adhesion via plasma membrane cell adhesion molecules"),
c("GO:0007631","feeding behavior",0.026,0.7818,0.990,0.000,"feeding behavior"),
c("GO:1905243","cellular response to 3,3',5-triiodo-L-thyronine",0.000,0.8929,0.901,0.000,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:0002223","stimulatory C-type lectin receptor signaling pathway",0.001,0.8717,0.747,0.160,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:0007214","gamma-aminobutyric acid signaling pathway",0.008,0.8474,0.811,0.245,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:0010269","response to selenium ion",0.001,0.8692,0.920,0.250,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:0032486","Rap protein signal transduction",0.002,0.8472,0.822,0.252,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:1901537","positive regulation of DNA demethylation",0.000,0.8257,0.781,0.312,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:2000676","positive regulation of type B pancreatic cell apoptotic process",0.000,0.8442,0.802,0.338,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:0031098","stress-activated protein kinase signaling cascade",0.060,0.8312,0.780,0.341,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:0031274","positive regulation of pseudopodium assembly",0.002,0.8650,0.700,0.362,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:0001666","response to hypoxia",0.049,0.8258,0.905,0.392,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:0019722","calcium-mediated signaling",0.040,0.8027,0.795,0.405,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:0048015","phosphatidylinositol-mediated signaling",0.061,0.8032,0.790,0.417,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:0006301","postreplication repair",0.023,0.8296,0.829,0.432,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:1990090","cellular response to nerve growth factor stimulus",0.004,0.8585,0.877,0.432,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:0036297","interstrand cross-link repair",0.018,0.8119,0.831,0.436,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:0002574","thrombocyte differentiation",0.001,0.8638,0.783,0.437,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:0051103","DNA ligation involved in DNA repair",0.039,0.8035,0.824,0.458,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:0000165","MAPK cascade",0.245,0.7956,0.678,0.461,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:0001558","regulation of cell growth",0.094,0.8009,0.704,0.462,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:0048013","ephrin receptor signaling pathway",0.016,0.8353,0.782,0.463,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:0019885","antigen processing and presentation of endogenous peptide antigen via MHC class I",0.005,0.7967,0.973,0.479,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:0018108","peptidyl-tyrosine phosphorylation",0.188,0.7680,0.852,0.497,"cellular response to 3,3prime,5-triiodo-L-thyronine"),
c("GO:0072382","minus-end-directed vesicle transport along microtubule",0.000,0.8775,0.811,0.011,"minus-end-directed vesicle transport along microtubule"),
c("GO:0010248","establishment or maintenance of transmembrane electrochemical gradient",0.007,0.8598,0.941,0.121,"minus-end-directed vesicle transport along microtubule"),
c("GO:0070086","ubiquitin-dependent endocytosis",0.002,0.8638,0.874,0.216,"minus-end-directed vesicle transport along microtubule"),
c("GO:2001256","regulation of store-operated calcium entry",0.005,0.8521,0.847,0.285,"minus-end-directed vesicle transport along microtubule"),
c("GO:0015876","acetyl-CoA transport",0.009,0.8457,0.883,0.293,"minus-end-directed vesicle transport along microtubule"),
c("GO:0033227","dsRNA transport",0.005,0.8491,0.879,0.325,"minus-end-directed vesicle transport along microtubule"),
c("GO:0035418","protein localization to synapse",0.006,0.7901,0.934,0.345,"minus-end-directed vesicle transport along microtubule"),
c("GO:0030317","flagellated sperm motility",0.017,0.8437,0.823,0.403,"minus-end-directed vesicle transport along microtubule"),
c("GO:0071918","urea transmembrane transport",0.010,0.8398,0.884,0.414,"minus-end-directed vesicle transport along microtubule"),
c("GO:0045022","early endosome to late endosome transport",0.007,0.8537,0.897,0.436,"minus-end-directed vesicle transport along microtubule"),
c("GO:0045041","protein import into mitochondrial intermembrane space",0.004,0.8499,0.750,0.438,"minus-end-directed vesicle transport along microtubule"),
c("GO:0071985","multivesicular body sorting pathway",0.002,0.8167,0.884,0.442,"minus-end-directed vesicle transport along microtubule"),
c("GO:1902476","chloride transmembrane transport",0.047,0.7708,0.933,0.455,"minus-end-directed vesicle transport along microtubule"),
c("GO:0071427","mRNA-containing ribonucleoprotein complex export from nucleus",0.056,0.7988,0.900,0.480,"minus-end-directed vesicle transport along microtubule"),
c("GO:0072488","ammonium transmembrane transport",0.086,0.7693,0.925,0.486,"minus-end-directed vesicle transport along microtubule"),
c("GO:1903094","negative regulation of protein K48-linked deubiquitination",0.000,0.8688,0.780,0.012,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0035633","maintenance of permeability of blood-brain barrier",0.000,0.7634,0.901,0.100,"negative regulation of protein K48-linked deubiquitination"),
c("GO:2000582","positive regulation of ATP-dependent microtubule motor activity, plus-end-directed",0.000,0.8233,0.893,0.102,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0005981","regulation of glycogen catabolic process",0.002,0.8618,0.752,0.166,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0018057","peptidyl-lysine oxidation",0.000,0.8687,0.846,0.188,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0070212","protein poly-ADP-ribosylation",0.001,0.8630,0.827,0.196,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0018142","protein-DNA covalent cross-linking",0.001,0.8414,0.901,0.205,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0006465","signal peptide processing",0.050,0.7979,0.860,0.282,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0006182","cGMP biosynthetic process",0.032,0.8275,0.805,0.321,"negative regulation of protein K48-linked deubiquitination"),
c("GO:1902455","negative regulation of stem cell population maintenance",0.001,0.8680,0.758,0.326,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0006030","chitin metabolic process",0.077,0.7863,0.921,0.340,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0030277","maintenance of gastrointestinal epithelium",0.004,0.8563,0.766,0.367,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0009450","gamma-aminobutyric acid catabolic process",0.018,0.8123,0.811,0.373,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0006488","dolichol-linked oligosaccharide biosynthetic process",0.016,0.8135,0.841,0.380,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0016598","protein arginylation",0.017,0.8202,0.840,0.400,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0030641","regulation of cellular pH",0.028,0.8373,0.800,0.441,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0042391","regulation of membrane potential",0.135,0.7917,0.865,0.442,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0070534","protein K63-linked ubiquitination",0.010,0.8508,0.875,0.443,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0006665","sphingolipid metabolic process",0.093,0.7818,0.835,0.447,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0006707","cholesterol catabolic process",0.002,0.7998,0.853,0.448,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0006203","dGTP catabolic process",0.003,0.8054,0.804,0.455,"negative regulation of protein K48-linked deubiquitination"),
c("GO:1905247","positive regulation of aspartic-type peptidase activity",0.000,0.7472,0.789,0.458,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0032332","positive regulation of chondrocyte differentiation",0.003,0.8589,0.689,0.466,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0007416","synapse assembly",0.038,0.8442,0.669,0.474,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0005992","trehalose biosynthetic process",0.060,0.7833,0.831,0.479,"negative regulation of protein K48-linked deubiquitination"),
c("GO:0007023","post-chaperonin tubulin folding pathway",0.020,0.8404,0.965,0.016,"post-chaperonin tubulin folding pathway"),
c("GO:0006914","autophagy",0.230,0.7702,0.960,0.022,"autophagy"),
c("GO:0001935","endothelial cell proliferation",0.022,0.8555,0.935,0.036,"endothelial cell proliferation"),
c("GO:0039693","viral DNA genome replication",0.004,0.8362,0.875,0.063,"viral DNA genome replication"),
c("GO:0006384","transcription initiation from RNA polymerase III promoter",0.007,0.8341,0.905,0.134,"viral DNA genome replication"),
c("GO:0006366","transcription from RNA polymerase II promoter",1.430,0.7607,0.869,0.290,"viral DNA genome replication"),
c("GO:0006368","transcription elongation from RNA polymerase II promoter",0.082,0.8149,0.886,0.352,"viral DNA genome replication"),
c("GO:0071688","striated muscle myosin thick filament assembly",0.003,0.8638,0.671,0.076,"striated muscle myosin thick filament assembly"),
c("GO:0071711","basement membrane organization",0.008,0.8540,0.804,0.243,"striated muscle myosin thick filament assembly"),
c("GO:0042545","cell wall modification",0.045,0.8018,0.844,0.284,"striated muscle myosin thick filament assembly"),
c("GO:0051878","lateral element assembly",0.000,0.7874,0.782,0.306,"striated muscle myosin thick filament assembly"),
c("GO:0000460","maturation of 5.8S rRNA",0.066,0.8141,0.774,0.335,"striated muscle myosin thick filament assembly"),
c("GO:0031581","hemidesmosome assembly",0.002,0.8466,0.803,0.337,"striated muscle myosin thick filament assembly"),
c("GO:0070828","heterochromatin organization",0.012,0.8507,0.840,0.373,"striated muscle myosin thick filament assembly"),
c("GO:1905198","manchette assembly",0.000,0.7917,0.755,0.381,"striated muscle myosin thick filament assembly"),
c("GO:0010172","embryonic body morphogenesis",0.005,0.8562,0.822,0.402,"striated muscle myosin thick filament assembly"),
c("GO:0033334","fin morphogenesis",0.003,0.8522,0.829,0.407,"striated muscle myosin thick filament assembly"),
c("GO:0006421","asparaginyl-tRNA aminoacylation",0.029,0.7973,0.784,0.422,"striated muscle myosin thick filament assembly"),
c("GO:0000278","mitotic cell cycle",0.561,0.7467,0.833,0.429,"striated muscle myosin thick filament assembly"),
c("GO:0061739","protein lipidation involved in autophagosome assembly",0.000,0.8436,0.760,0.436,"striated muscle myosin thick filament assembly"),
c("GO:0006378","mRNA polyadenylation",0.044,0.8082,0.890,0.442,"striated muscle myosin thick filament assembly"),
c("GO:0090286","cytoskeletal anchoring at nuclear membrane",0.004,0.8269,0.676,0.462,"striated muscle myosin thick filament assembly"),
c("GO:0098725","symmetric cell division",0.001,0.7530,0.900,0.083,"symmetric cell division"),
c("GO:0045197","establishment or maintenance of epithelial cell apical/basal polarity",0.008,0.8507,0.888,0.094,"establishment or maintenance of epithelial cell apical/basal polarity"),
c("GO:0006556","S-adenosylmethionine biosynthetic process",0.050,0.7850,0.925,0.095,"S-adenosylmethionine biosynthesis"),
c("GO:0016104","triterpenoid biosynthetic process",0.005,0.8337,0.863,0.097,"triterpenoid biosynthesis"),
c("GO:0006564","L-serine biosynthetic process",0.075,0.7776,0.823,0.230,"triterpenoid biosynthesis"),
c("GO:0006662","glycerol ether metabolic process",0.122,0.7520,0.895,0.230,"triterpenoid biosynthesis"),
c("GO:0006596","polyamine biosynthetic process",0.117,0.7567,0.912,0.242,"triterpenoid biosynthesis"));

stuff <- data.frame(revigo.data);
names(stuff) <- revigo.names;

stuff$value <- as.numeric( as.character(stuff$value) );
stuff$freqInDbPercent <- as.numeric( as.character(stuff$freqInDbPercent) );
stuff$uniqueness <- as.numeric( as.character(stuff$uniqueness) );
stuff$dispensability <- as.numeric( as.character(stuff$dispensability) );

# by default, outputs to a PDF file
pdf( file="revigo_treemap.pdf", width=16, height=9 ) # width and height are in inches

# check the tmPlot command documentation for all possible parameters - there are a lot more
tmPlot(
	stuff,
	index = c("representative","description"),
	vSize = "value",
	type = "categorical",
	vColor = "representative",
	title = "REVIGO Gene Ontology treemap",
	inflate.labels = FALSE,      # set this to TRUE for space-filling group labels - good for posters
	lowerbound.cex.labels = 0,   # try to draw as many labels as possible (still, some small squares may not get a label)
	bg.labels = "#CCCCCCAA",     # define background color of group labels
												       # "#CCCCCC00" is fully transparent, "#CCCCCCAA" is semi-transparent grey, NA is opaque
	position.legend = "none"
)

dev.off()
